;---------------------------------------
; Main loop file
;---------------------------------------
wcKernel	equ	#6006				; WildCommander API
sxgBufferSize	equ	16					; 16*512 = 8192      (512)

		org	#6200
		DISP	#8000
;    
startCode
		ld	(storeIx),ix
		cp	#00				;   
		jp	z,start
;		cp	#01				;    
;		jp	z,callAtStart
;		cp	#03				;     
;		jp	z,callFromMenu
		jp	wrongExit

;---------------
start
callFromExt	ld	(fileLength),hl
		ld	(fileLength+2),de

		ld	hl,sxgBuffer
		ld	b,sxgBufferSize
		ld	a,_LOAD512
		ex	af,af'
		call	wcKernel

		ld	hl,sxgBuffer
		ld	a,(hl)
		cp	#7f
		jp	nz,wrongExit
		
		inc	hl
		ld	a,(hl)
		cp	"S"
		jp	nz,wrongExit

		inc	hl
		ld	a,(hl)
		cp	"X"
		jp	nz,wrongExit

		inc	hl
		ld	a,(hl)
		cp	"G"
		jp	nz,wrongExit

		inc	hl
		ld	a,(hl)
		ld	(imageMode),a

		push	hl
		call	setImageMode
		pop	hl

		cp	#ff					; error -> exit
		jr	z,wrongExit

		inc	hl
		ld	c,(hl)					; Width 0-512
		inc	hl
		ld	b,(hl)

		call	sxgAlignX

;---------------
		ld	a,(imageMode)				; TODO: ZX Mode(?)
		cp	#01					; 16c
		jr	nz,skipImageDec

		ld	a,#01
		ld	(widthLoop+2),a

		xor	a					; /2 = 4   
		srl	b
		rr	c
		jr	nc,skipImageDec
		inc	c

skipImageDec	ld	(imageWidth),bc
		ld	(countWidth),bc

		inc	hl
		ld	c,(hl)					; Height 0-512
		inc	hl
		ld	b,(hl)

		call	sxgAlignY

		ld	(imageHeight),bc
		ld	(countHeight),bc
;---------------
		inc	hl
		ld	c,(hl)					;  ()    
		inc	hl
		ld	b,(hl)

		inc	hl

		push	hl
		add	hl,bc					;   
gPalNum		ld	b,#01					;      
		ld	a,setGfxPalette
		call	cliKernel

		pop	hl

		ld	c,(hl)					;  ()    bitmap
		inc	hl
		ld	b,(hl)

		inc	hl
		add	hl,bc					;   bitmap
;---------------
		call	setVBank

	
;---------------
pluginExit	call	restoreExit
		ld	ix,(storeIx)
		xor	a	 			;  
		ret

wrongExit	call	restoreExit
		ld	ix,(storeIx)
		ld	a,1	 			;   ,   / 
		ret

restoreExit	ld	a,#00				;    WC (#00 -   ())
		ex	af,af'
		ld	a,_MNGV_PL
		jp	wcKernel
;---------------
storeIx		dw	#0000
fileLength	dw	#0000,#0000

endCode		nop

		org	#e000
sxgBuffer	nop